#ifndef __ODIN3_PROTO_H__
#define __ODIN3_PROTO_H__

typedef enum {
	RQT_INIT =	100, /* Init Request */
	RQT_PIT =	101, /* PIT Request */
	RQT_XMIT =	102, /* XMIT Request */
	RQT_CLOSE =	103, /* Close Request */
} request_type;

/* Request Data */
/* RQT_INIT 100 */
enum {
	RQT_INIT_DATA_TARGET = 0,
	RQT_INIT_DATA_RESETTIME,
	RQT_INIT_DATA_TOTALSIZE,
	RQT_INIT_DATA_OEMSTATE,
	RQT_INIT_DATA_NOOEMSTATE,
	RQT_INIT_DATA_PACKETSIZE,
	RQT_INIT_DATA_XMITSIZE,
};

/* RQT_PIT 101 */
enum {
	RQT_PIT_DATA_SET = 0,
	RQT_PIT_DATA_GET,
	RQT_PIT_DATA_START,
	RQT_PIT_DATA_COMPLETE,
};

/* RQT_XMIT 102 */
enum {
	RQT_XMIT_DATA_DOWNLOAD = 0,
	RQT_XMIT_DATA_DUMP,
	RQT_XMIT_DATA_START,
	RQT_XMIT_DATA_COMPLETE,
	RQT_XMIT_DATA_SMD,
};

/* RQT_CLOSE 103 */
enum {
	RQT_CLOSE_DATA_END = 0,
	RQT_CLOSE_DATA_REBOOT,
};

enum {
        BINARY_TYPE_AP = 0,
        BINARY_TYPE_CP,
};

enum {
        PARTITION_DEV_TYPE_ONENAND = 0,
        PARTITION_DEV_TYPE_NAND,
	/* 
	 * u-boot-slp treats nand as a file since Jan 12, 2011 
	 * Change-Id: I587cea1abf09b3a1712f5e31ab1c5d2887901960
	 */
        PARTITION_DEV_TYPE_FILE = PARTITION_DEV_TYPE_NAND,
        PARTITION_DEV_TYPE_MOVINAND,
};

enum {
        PARTITION_ATTR_RO = 0,
        PARTITION_ATTR_RW,
        PARTITION_ATTR_STL,
};

enum {
        PARTITION_UPDATE_ATTR_NONE = 0,
        PARTITION_UPDATE_ATTR_FOTA,
        PARTITION_UPDATE_ATTR_SECURE,
        PARTITION_UPDATE_ATTR_FOTA_SECURE,
};

enum {
        DUMP_MODE_AP_RAM = 0,
        DUMP_MODE_AP_NAND,
};

struct request_packet {
	int32_t	id;		/* Req. ID */
	int32_t	sub_id;		/* Req. sub ID */
	int32_t	int_data[7];	/* integer data */
	uint8_t	str_data[128];	/* string data eg) firmware file name? */
	uint8_t md5[32];	/* md5 checksum */
	uint8_t pad[828];	/* 1KB alignment */
};

#define INIT_REQUEST_SIZE (sizeof (struct request_packet))

struct response_packet {
	int32_t	id;		/* Resp. ID == Req. ID */
	int32_t	ack;		/* Ack (or reply data) */
};

#endif /* __ODIN3_PROTO_H__ */
